/* Tiny E2 NAND 'driver'
   It'd be nice if this'd cope with internal on-board NAND and 'external' Smartmedia cards
   (c) Matt Evans 26Mar05

   THIS CODE IS NOT USED IN THE USUAL BUILD, it is included for ... no reason.
   It successfully reads the raw flash pages, but does not implement FTL stuff so 
   is useless for now.
*/


#include "nand.h"
#include "peripherals.h"
#include "asmfns.h"

//#define TINYWAIT
#define TINYWAIT asm __volatile__("nop; nop; nop; ")
//#define TINYWAIT asm __volatile__("mov r9, #0\n 1: subs r9, r9, #1\n bgt 1b\n" \
//                                    : : : "r9");

#define MEDIUMWAIT asm __volatile__("mov r9, #16\n 1: subs r9, r9, #1\n bgt 1b\n" \
                                    : : : "r9");

#define LONGWAIT asm __volatile__("mov r9, #1024\n 1: subs r9, r9, #1\n bgt 1b\n" \
                                  : : : "r9");

#define SETNCTRL(x) { nandctrl[NAND_CTRL] = nctrl = x; }
// A command (CLE) bus write cycle
#define WRITECMD(x) { nandctrl[NAND_DATA] = x; nandctrl[NAND_CTRL] = (nctrl |= NAND_CTRL_CLE); TINYWAIT; \
                      nandctrl[NAND_CTRL] = (nctrl |= NAND_CTRL_WE); MEDIUMWAIT; \
                      nandctrl[NAND_CTRL] = (nctrl &= ~NAND_CTRL_WE); TINYWAIT; \
                      nandctrl[NAND_CTRL] = (nctrl &= ~NAND_CTRL_CLE); }
// An address (ALE) bus write cycle - just 1, not full address.
#define WRITEADDR1(x) { nandctrl[NAND_DATA] = x; nandctrl[NAND_CTRL] = (nctrl |= NAND_CTRL_ALE); TINYWAIT; \
                        nandctrl[NAND_CTRL] = (nctrl |= NAND_CTRL_WE); MEDIUMWAIT; \
                        nandctrl[NAND_CTRL] = (nctrl &= ~NAND_CTRL_WE); TINYWAIT; \
                        nandctrl[NAND_CTRL] = (nctrl &= ~NAND_CTRL_ALE); TINYWAIT; }

// A full address (ALE) bus write cycle, 3 writes.
#define WRITEADDR3(x) { nandctrl[NAND_CTRL] = (nctrl |= NAND_CTRL_ALE); \
                        nandctrl[NAND_DATA] = (x & 0xff); TINYWAIT; \
                        nandctrl[NAND_CTRL] = (nctrl |= NAND_CTRL_WE); TINYWAIT; \
                        nandctrl[NAND_CTRL] = (nctrl &= ~NAND_CTRL_WE); TINYWAIT; \
                        nandctrl[NAND_DATA] = ((x >> 8) & 0xff); TINYWAIT; \
                        nandctrl[NAND_CTRL] = (nctrl |= NAND_CTRL_WE); TINYWAIT; \
                        nandctrl[NAND_CTRL] = (nctrl &= ~NAND_CTRL_WE); TINYWAIT; \
                        nandctrl[NAND_DATA] = ((x >> 16) & 0xff); TINYWAIT; \
                        nandctrl[NAND_CTRL] = (nctrl |= NAND_CTRL_WE); TINYWAIT; \
                        nandctrl[NAND_CTRL] = (nctrl &= ~NAND_CTRL_WE); TINYWAIT; \
                        nandctrl[NAND_CTRL] = (nctrl &= ~NAND_CTRL_ALE); TINYWAIT; }

#define WRITEADDR4(x) { nandctrl[NAND_CTRL] = (nctrl |= NAND_CTRL_ALE); \
                        nandctrl[NAND_DATA] = (x & 0xff); TINYWAIT; \
                        nandctrl[NAND_CTRL] = (nctrl |= NAND_CTRL_WE); TINYWAIT; \
                        nandctrl[NAND_CTRL] = (nctrl &= ~NAND_CTRL_WE); TINYWAIT; \
                        nandctrl[NAND_DATA] = ((x >> 8) & 0xff); TINYWAIT; \
                        nandctrl[NAND_CTRL] = (nctrl |= NAND_CTRL_WE); TINYWAIT; \
                        nandctrl[NAND_CTRL] = (nctrl &= ~NAND_CTRL_WE); TINYWAIT; \
                        nandctrl[NAND_DATA] = ((x >> 16) & 0xff); TINYWAIT; \
                        nandctrl[NAND_CTRL] = (nctrl |= NAND_CTRL_WE); TINYWAIT; \
                        nandctrl[NAND_CTRL] = (nctrl &= ~NAND_CTRL_WE); TINYWAIT; \
                        nandctrl[NAND_DATA] = ((x >> 24) & 0xff); TINYWAIT; \
                        nandctrl[NAND_CTRL] = (nctrl |= NAND_CTRL_WE); TINYWAIT; \
                        nandctrl[NAND_CTRL] = (nctrl &= ~NAND_CTRL_WE); TINYWAIT; \
                        nandctrl[NAND_CTRL] = (nctrl &= ~NAND_CTRL_ALE); TINYWAIT; }

// A read bus cycle
#define READ(x) { nandctrl[NAND_CTRL] = (nctrl |= NAND_CTRL_RE); MEDIUMWAIT; x = nandctrl[NAND_DATA]; \
                  nandctrl[NAND_CTRL] = (nctrl &= ~NAND_CTRL_RE); TINYWAIT; }


// NAND manufacturer codes/device ID codes //
// Values are from linux/include/linux/mtd/nand.h and linux/drivers/mtd/nand/nand_ids.c
struct nandManu nManufTable[] = { 
{ 0x01, "AMD    " },
{ 0x04, "Fujitsu" },
{ 0x98, "Toshiba" },
{ 0xec, "Samsung" },
{ 0x8f, "NatSemi" },
{ 0x07, "Renesas" },
{ 0x20, "STmicro" } };

int numManus = sizeof(nManufTable) / sizeof(struct nandManu);

// ID, capacity, pagesize, blocksize
struct nandDevice nDeviceTable[] = {
/*{ 0x6e, 0x100000, 256, 4096 },
{ 0x64, 0x200000, 256, 4096 },
{ 0x6b, 0x400000, 512, 8192 },
{ 0xe8, 0x100000, 256, 4096 },
{ 0xec, 0x100000, 256, 4096 },
{ 0xea, 0x200000, 256, 4096 },
{ 0xd5, 0x400000, 512, 8192 },
{ 0xe3, 0x400000, 512, 8192 },
{ 0xe5, 0x400000, 512, 8192 },*/
{ 0xd6, 0x800000, 512, 8192 },
{ 0x39, 0x800000, 512, 8192 },
{ 0xe6, 0x800000, 512, 8192 },
{ 0x49, 0x800000, 512, 8192 },
{ 0x59, 0x800000, 512, 8192 },
{ 0x33, 0x1000000, 512, 16384 },
{ 0x73, 0x1000000, 512, 16384 },
{ 0x43, 0x1000000, 512, 16384 },
{ 0x53, 0x1000000, 512, 16384 },
{ 0x35, 0x2000000, 512, 16384 },
{ 0x75, 0x2000000, 512, 16384 },
{ 0x45, 0x2000000, 512, 16384 },
{ 0x55, 0x2000000, 512, 16384 },
{ 0x36, 0x4000000, 512, 16384 },
{ 0x76, 0x4000000, 512, 16384 }, // My SM card
{ 0x46, 0x4000000, 512, 16384 },
{ 0x56, 0x4000000, 512, 16384 },
{ 0x78, 0x8000000, 512, 16384 },
{ 0x79, 0x8000000, 512, 16384 },
{ 0x72, 0x8000000, 512, 16384 },
{ 0x74, 0x8000000, 512, 16384 },
{ 0x71, 0x10000000, 512, 16384 },
{ 0xdc, 0x20000000, 512, 16384 },
{ 0xdc, 0x20000000, 512, 16384 }
};
int numDevices = sizeof(nDeviceTable) / sizeof(struct nandDevice);
  
void nand_listdevs(struct nandInfo *ni)
{
  int i, m;
  // Dump info about available flash devices
  uart_putstring("     Manufacturer Device Blocksize Pagesize Capacity\r\n");
  for (i = 0; i < MAX_FLASH_DEVS; i++)
  { 
    uart_phex8(i);
    uart_putbyte(' ');
    if (ni[i].chipsel)
    {
      int mfound = -1;
      uart_putstring("       ");
      for (m = 0; m < numManus; m++)
      {
        if (nManufTable[m].IDcode == ni[i].manuf)
        {
          mfound = m;
          break;
        }
      }
      if (mfound != -1)
      {
        uart_putstring(nManufTable[m].name);
      }
      else
      {
        uart_putstring("     ");
        uart_phex8(ni[i].manuf);
      }
      uart_putbyte(' ');
      uart_phex8(ni[i].device);
      uart_putstring("     ");  // yuck!  gimme a printf :(
      uart_phex32(ni[i].blocksize);
      uart_putstring("  ");
      uart_phex32(ni[i].pagesize);
      uart_putbyte(' ');
      uart_phex32(ni[i].capacity);
      uart_pnewl();
    }
    else
    {
      uart_putstring("         --- Not present ---\r\n");
    }
  }  
}

// Wait for the busy/ready signal to signal ready
void nand_waitTillReady(void)
{
  volatile unsigned char *nandctrl = (volatile unsigned char *)NAND_BASE;

  while ((nandctrl[NAND_STATUS] & NAND_STATUS_BUSY)) { }
}

inline int nand_checkbusy(void)
{
  volatile unsigned char *nandctrl = (volatile unsigned char *)NAND_BASE;
  int j = nandctrl[NAND_STATUS]; //uart_phex8(j);
  return (j & NAND_STATUS_BUSY);
}

// Initialise anything we need; reset the internal NAND (what about external?)
// and wait for it to become ready.
void nand_init(void)
{
  volatile unsigned char *nandctrl = (volatile unsigned char *)NAND_BASE;
  int a = 0, b = 0;
//  volatile unsigned char *c = NAND_BASE;
  int nctrl;
  
  SETNCTRL(0);
  //SETNCTRL(NAND_CTRL_CS_INT);  // Ext?
  //WRITECMD(NAND_CMD_RESET);
  //nand_waitTillReady();
  //SETNCTRL(0);

  // Testing it 'by hand':
/*  nandctrl[6] = 0x90;
  nandctrl[5] = 0x01;
  nandctrl[5] = 0x81;
  nandctrl[5] = 0xa1;
  nandctrl[5] = 0x81;
  nandctrl[5] = 0x01;
  nandctrl[6] = 0;
  nandctrl[5] = 0x41;
  nandctrl[5] = 0x61;
  nandctrl[5] = 0x41;
  nandctrl[5] = 0x01;
  nandctrl[5] = 0x09;
  uart_phex8(nandctrl[6]);
  nandctrl[5] = 0x01;
  nandctrl[5] = 0x09;
  uart_phex8(nandctrl[6]);
  nandctrl[5] = 0x01;
  nandctrl[5] = 0x00;
  uart_pnewl();
  // That successfully reads the SMC's ID!
  */
}

// Find out if Smartmedia card is inserted - good for polling for one.
int nand_isExtCardPresent(void)
{
  volatile unsigned char *nandctrl = (volatile unsigned char *)NAND_BASE;
  
  return (nandctrl[NAND_STATUS] & NAND_STATUS_SMPRESENT) ? 1 : 0;
}

// Get the ID/manufacturer of the internal and external flash, block size and capacity
// Returns 0 on success, else an error occurred.
// Should (!) find 1 or 2 flash chips, depending on whether the Smartmedia card's inserted.
int nand_enumerate(struct nandInfo *inf, int *numfound)
{
  volatile unsigned char *nandctrl = (volatile unsigned char *)NAND_BASE;
  int cSel;
  int manufID, deviceID;
  int dev, found = 0;
  int nctrl;
  int caps = 0;
  
  for (dev = 0; dev < MAX_FLASH_DEVS; dev++)
  {
    switch (dev)
    {
      case 0:
        cSel = NAND_CTRL_CS_INT;
        break;
      case 1:
        if (nand_isExtCardPresent())
        {
          // This is all a guess; there seem to be 2 chip selects.  That COULD be for a dev board with
          // two such NAND chips, but I'm guessing one's for the Smartmedia and there's a flag to say if it's
          // present.
          cSel = NAND_CTRL_CS_EXT;
          caps |= NAND_CAP_FOUR_BYTE_READ;  // HACK: "SMC cards use 4-byte address".. uh, ok.
        }
        else
        {
          cSel = 0;
        }
        break;
      default:
        cSel = 0;  // Never get here
    }

    if (cSel)
    {
      int i, dfound = -1;
      
      SETNCTRL(0);
      SETNCTRL(cSel);
      WRITECMD(NAND_CMD_RD_ID);
      WRITEADDR1(0);
      MEDIUMWAIT;
      READ(manufID);
      READ(deviceID);
      SETNCTRL(0);
      
      // Look up the deviceID and manufactuer to get infos.
      inf[dev].manuf = manufID;
      inf[dev].device = deviceID;
      
      // Find device:
      for (i = 0; i < numDevices; i++)
      {
        if (nDeviceTable[i].IDcode == deviceID)
        {
          dfound = i;
          break;
        }
      }
      
      if (dfound != -1)
      {
        inf[dev].blocksize = nDeviceTable[dfound].blocksize;
        inf[dev].pagesize = nDeviceTable[dfound].pagesize;
        inf[dev].capacity = nDeviceTable[dfound].capacity;
      }
      else
      {
        uart_putstring("WARNING: Unknown flash device detected, manu:dev ");
        uart_phex8(manufID);
        uart_putbyte(':');
        uart_phex8(deviceID);
        uart_putstring("! Ignoring it.\r\n");
        inf[dev].blocksize = 0;
        inf[dev].pagesize = 0;
        inf[dev].capacity = 0;
      }
      found++;
      
      // Might want to select a device-dependent address formatter, too (e.g. addr lines may differ lots.)
      // The device struct could have callbacks to perform really low-level things.
    }
    inf[dev].chipsel = cSel;
    inf[dev].capabilities = caps;
  }
  *numfound = found;
  return 0;
}

/* nand_read(device, address of memory buffer to read into, offset into device in bytes,
             length in bytes)
   Provide a nicely abstracted interface to read data from the specified device regardless of blocksize 
   and page size etc.

   Returns 0 on success, NAND_EINVAL if the offset or length are inappropriate for the device, 
   NAND_ENODEV if the device isn't present or otherwise useful.
   NAND_EREADERROR if there was a peculiar situation when reading (or, in future, an ECC problem).
*/
int nand_read(struct nandInfo *dev, unsigned char *dest, unsigned int offset, unsigned int length)
{
  volatile unsigned char *nandctrl = (volatile unsigned char *)NAND_BASE;
  int upper, i, bytesToEndOfPage, addr;
  int pagesize;
  int nctrl;
  
  if (!dev->chipsel)
  {
    return NAND_ENODEV;
  }
  if ((offset + length) >= dev->capacity)
  {
    return NAND_EINVAL;
  }
  
  // Right!  The read may be starting in the middle of a page- work out which half and
  // choose the appropriate read-half-page command.  (NOTE: should check device capabilities, maybe
  // we don't have to do this for this particular chip?  (E2 am30lv008 needs it.))
  // FIXME in future support 'gapless read' on AMD flash - it's quicker.
  pagesize = dev->pagesize;  // 50p says the compiler doesn't spot this fold...
  bytesToEndOfPage = pagesize - (offset & (pagesize-1));  // Including the one offset points to!
  upper = (offset & (pagesize >> 1)) ? 1 : 0;  // Bit A8 set?
  
  SETNCTRL(0);
  SETNCTRL(dev->chipsel);
  
  // OK so issue the read command:
  WRITECMD(/*NAND_CMD_RD_GAPLESS*/upper ? NAND_CMD_RD_H : NAND_CMD_RD_L);
  
  if (dev->capabilities & NAND_CAP_FOUR_BYTE_READ)
  {
    // 4-byte address
    // format the initial address: byte 1 = a[7:0], byte 2 = a[16:9], byte 3 = a[24:17], byte 4 = a[25]xxxxxxx
    addr = (offset & 0xff) | ((offset & 0x1fffe00) >> 1) | ((offset & 0x2000000) >> 1);
    WRITEADDR4(addr);
  }
  else
  {
    // format the initial address: byte 1 = a[7:0], byte 2 = a[16:9], byte 3 = a[24:17]
    addr = (offset & 0xff) | ((offset & 0x1fffe00) >> 1);
    WRITEADDR3(addr);
  }
  
  // Now there's a few us while the page comes in.
  nand_waitTillReady();
  
  // Begin reading the data until the end of the page - THEN need to wait for the ready signal again!
  for (i = 0; i < length; i++)
  {
    READ(dest[i]);
//    uart_phex32(bytesToEndOfPage);
    //uart_phex8(dest[i]);
    //uart_putbyte(':');
    if (--bytesToEndOfPage == 0)
    {
      // Rolling onto next page; wait.
      bytesToEndOfPage = pagesize;
      nand_waitTillReady();
    }
/*    else if (nand_checkbusy())   // assert(busy flag NOT waving) - only expected at end of page, as below.
    {
      uart_putstring("nand_read: Busy flag seen in middle of page!  (page offset ");
      uart_phex32(pagesize - bytesToEndOfPage);
      uart_putstring(")\r\n");
//      return NAND_EREADERROR;
    }*/
    nand_waitTillReady();
      
    // FIXME: Read the spare area here, perform ECC checks and recovery.
  }
  SETNCTRL(0);
  // Theoretical max speed:  512 bytes, at 50ns (best case) per byte, plus 7ns per page
  // is 32600ns for 512 bytes.  That's 30674 pages/sec, which is about 15.7MB/s.  With gapless read, 
  // a page is read in 25600ns, which is about 20MB/s.
  // The code above will never hit 50ns per byte :)
  return 0;
}

/* nand_write(device, memory buffer, offset into flash to begin from, length to write)
   Ahh, more complicated.  Block erasure and page programs are wrapped up in here so they're invisible.

   Returns 0 on success.
   Errors may include those of nand_read for malformed arguments, and NAND_EWRITEERROR if there was a write
   problem.  (This can be caused by failure to correctly erase/program as signalled by the status reg.)
 */
int nand_write(struct nandInfo *dev, unsigned char *from, unsigned int dest_offset, unsigned int length)
{
  volatile unsigned char *nandctrl = (volatile unsigned char *)NAND_BASE;
  // check arguments.
  
  // Prologue: If dest_offset is NOT block-aligned then a write to a fraction of a block is desired.
  // So read the data from the block, erase it, overlay our data into the backup, and program the whole
  // thing back in.  (Optimisation - spot whether erasure can be avoided by checking pages are 'empty'?)
  
  // Main loop:  erase blocks and program them in their entirety.
  
  // Epilogue: if the length brings us into the middle of the last block, but is not aligned, then
  // we must do as Prologue - copy out last block, overlay data, erase, program the whole thing back.
  
  // *** For all erase/program operaions check statusReg[0] for success - retry or return error if not!
  uart_putstring("nand_write: Function unimplemented.\r\n");
  return NAND_ENODEV;
}
