/* Rudimentary timer init/reading fns.
   (c) Matt Evans 8 May 2005
*/

#include "peripherals.h"

#include "time.h"

volatile unsigned int *ct_base = (volatile unsigned int *)CT_BASE;

void time_init(void)
{
  ct_base[CT0_CTRL/4] = 0x88;  // prescale /1024
  ct_base[CT1_CTRL/4] = 0x8a;  // as above, but carry-in from CT0
  ct_base[CT2_CTRL/4] = 0;
  
  ct_base[CT0_LOAD/4] = 0xffff;
  ct_base[CT1_LOAD/4] = 0xffff;
}

// Counters count downwards, at 1/50000th sec per tick.  50 ticks = 1ms
//

// Counts upwards:
inline unsigned int time_now(void)
{
  unsigned int lower = ct_base[CT0_VALUE/4];
  unsigned int upper = ct_base[CT1_VALUE/4];
  
  return ~((lower & 0xffff) | (upper << 16));
}
